"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
exports._react = React;
var cache_1 = require("./internal/cache");
exports.Cache = cache_1.default;
var hoc_1 = require("./internal/hoc");
var registry_1 = require("./internal/registry");
exports.Registry = registry_1.default;
var renderer_1 = require("./internal/renderer");
exports.Renderer = renderer_1.default;
var utils_1 = require("./internal/utils");
exports.extend = utils_1.dynamicExtend;
exports.shallowCompare = utils_1.shallowCompare;
var types = require("./types");
exports.types = types;
exports.defaultRenderer = new renderer_1.default({ autoGenerateTag: true });
exports.getStyles = exports.defaultRenderer.getStyles.bind(exports.defaultRenderer);
exports.setDefaultRenderer = function (renderer) {
    exports.defaultRenderer = renderer;
    exports.getStyles = exports.defaultRenderer.getStyles.bind(exports.defaultRenderer);
    return exports.defaultRenderer;
};
var withStyles = function (options) {
    return options ?
        hoc_1.default({
            plugins: options.plugins || undefined,
            renderer: options.renderer || exports.defaultRenderer,
            shouldStylesUpdate: options.shouldStylesUpdate || utils_1.shallowCompare,
        })
        : hoc_1.default({
            renderer: exports.defaultRenderer,
            shouldStylesUpdate: utils_1.shallowCompare,
        });
};
exports.default = withStyles;
//# sourceMappingURL=index.js.map