"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var registry_1 = require("./registry");
exports.getRequestAnimationFrame = function () { return typeof requestAnimationFrame === 'undefined' ?
    setTimeout
    : requestAnimationFrame.bind(window); };
var Renderer = (function (_super) {
    __extends(Renderer, _super);
    function Renderer(_a) {
        var _b = _a === void 0 ? {} : _a, autoGenerateTag = _b.autoGenerateTag, plugins = _b.plugins, tag = _b.tag;
        var _this = _super.call(this, { plugins: plugins }) || this;
        _this.pending = 0;
        _this.lastFreeStyleChangeId = _this.freeStyle.changeId;
        _this.autoGenerateTag = autoGenerateTag;
        _this.tag = tag;
        _this.forceRenderStyles = _this.forceRenderStyles.bind(_this);
        _this.on(_this.styleUpdated.bind(_this));
        return _this;
    }
    Renderer.prototype.forceRenderStyles = function () {
        var target = this.getTag();
        if (target)
            target.textContent = this.getStyles();
        return this;
    };
    Renderer.prototype.setStylesTarget = function (tag) {
        if (this.tag)
            this.tag.textContent = '';
        this.tag = tag;
        this.forceRenderStyles();
        return this;
    };
    Renderer.prototype.getTag = function () {
        if (this.tag)
            return this.tag;
        if (this.autoGenerateTag) {
            var isServer = typeof document === 'undefined'
                || process.env.NODE_ENV === 'test' && window.isServer;
            var tag = isServer ?
                { textContent: '' }
                : document.createElement('style');
            if (!isServer)
                document.head.appendChild(tag);
            this.tag = tag;
            return tag;
        }
    };
    Renderer.prototype.styleUpdated = function () {
        var changeId = this.freeStyle.changeId;
        var lastChangeId = this.lastFreeStyleChangeId;
        if (changeId === lastChangeId)
            return this;
        this.lastFreeStyleChangeId = changeId;
        return this.sync(this.forceRenderStyles);
    };
    Renderer.prototype.sync = function (callback) {
        var _this = this;
        this.pending += 1;
        var pending = this.pending;
        Renderer.requestAnimationFrame(function () {
            if (pending === _this.pending)
                callback();
        });
        return this;
    };
    Renderer.requestAnimationFrame = exports.getRequestAnimationFrame();
    return Renderer;
}(registry_1.default));
exports.default = Renderer;
//# sourceMappingURL=renderer.js.map